/*
-----------------------------------------------------------------------------
This AREXX-Script will give as much information as it can about an image.

Host address: ADPro (Art Department Professional   ASDG)
Written by Jan Van Overbeke, 3-DEE, 1993.
Read the AREXX-Scripti doc, for info about operation and rights!
-----------------------------------------------------------------------------
*/

arg filename
if ~exists(filename)|filename='' then do
	say 'Unable to find the image!!!'
	say 'See Ya......'
	say ''
	exit
	end

address 'ADPro'
options results
say 'ImageInfo: Written by JAN VAN OVERBEKE, 3-DEE, 1993'
say 'Image: 'filename
say ''

LFORMAT 'UNIVERSAL'
if RC~=0 then do
	say 'Unable to select the UNIVERSAL loader.'
	say 'See Ya.......'
	say ''
	exit
	end

load filename
if RC~=0 then do
	say 'Load failed!!!!!!'
	say 'See Ya......'
	say ''
	exit
	end

/* ---- Info about size ---- */
/* ------------------------- */
XSIZE
w=ADPRO_RESULT
YSIZE
h=ADPRO_RESULT
/* ---- Info about colors ---- */
/* --------------------------- */
RENDER_TYPE
c=ADPRO_RESULT
/* ---- Info about image status ---- */
/* --------------------------------- */
IMAGE
help=ADPRO_RESULT
m=word(help,1)
if pos('RENDERED',help)>0|pos('BITPLANE',help)>0 then r='RENDERED'
					       else r='NOT RENDERED'

/* ---- What kind of screenmode have we got here? ---- */
/* ---- If the image is 24Bit, there's no screen! ---- */
/* --------------------------------------------------- */
if r='RENDERED' then do
	screen_type
	screenmode=ADPRO_RESULT
	if screenmode=6 then screenmode='Lores, Interlaced'
	if screenmode=4 then screenmode='Lores, Not Interlaced'
	if screenmode=7 then screenmode='Hires, Interlaced'
	if screenmode=5 then screenmode='Hires, Not Interlaced'
	if screenmode=35 then screenmode='Productivity, Hires, Interlaced (->VGA)'
	if screenmode=33 then
		screenmode='Productivity, Hires, Not Interlaced (->VGA)'
	if screenmode=70 then screenmode='Super-Hires, Interlaced'
	if screenmode=68 then screenmode='Super-Hires, Not Interlaced'
	if datatype(screenmode)='NUM' then screenmode='Code '||screenmode||' (?)'
	end
	else screenmode='No Screen!'


/* ---- Writing down results ---- */
/* ------------------------------ */
say 'ImageInfo:'
say '    Size  : 'w'x'h
if r~='RENDERED' then say '    Colors: 24Bit'
		else say '    Colors: 'c
say ' ColorMode: 'm
say '     Image: 'r
say '    Screen: 'screenmode
say ''

say 'Press [return] to end program.'
pull endd
exit
